SystemOrganization addCategory: #'Pier-Meta'!

!PRStructure methodsFor: '*pier-meta-accessing' stamp: 'lr 9/26/2007 19:33'!
description
	"Answer a generic description with the properties of the structure and with the defined fields of the receiver to make all the data properly editable and searchable."

	^ (MAContainer withAll: super description) , (self metamodel do: [ :each | each beEditable ])! !

!PRStructure methodsFor: '*pier-meta-accessing' stamp: 'lr 9/26/2007 19:34'!
metadata
	^ self propertyAt: #metadata ifAbsentPut: [ Dictionary new ]! !

!PRStructure methodsFor: '*pier-meta-accessing' stamp: 'lr 9/26/2007 19:32'!
metamodel
	^ self propertyAt: #metamodel ifAbsentPut: [ MAContainer new ]! !

!PRStructure methodsFor: '*pier-meta-accessing' stamp: 'lr 9/26/2007 19:35'!
readUsing: aDescription
	^ (self metamodel includes: aDescription)
		ifFalse: [ super readUsing: aDescription ]
		ifTrue: [ self metadata at: aDescription ifAbsentPut: [ aDescription default ] ]! !

!PRStructure methodsFor: '*pier-meta-accessing' stamp: 'lr 9/26/2007 19:37'!
write: anObject using: aDescription
	(self metamodel includes: aDescription)
		ifFalse: [ super write: anObject using: aDescription ]
		ifTrue: [ self metadata at: aDescription put: anObject ]! !

PRCommand subclass: #PRMetaEditCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Meta'!

!PRMetaEditCommand class methodsFor: 'testing' stamp: 'lr 9/26/2007 19:30'!
isAbstract
	^ false! !

!PRMetaEditCommand class methodsFor: 'accessing' stamp: 'lr 9/26/2007 19:30'!
label
	^ 'Edit Meta'! !

!PRMetaEditCommand methodsFor: 'accessing' stamp: 'lr 9/26/2007 19:52'!
description
	^ self metamodel description! !

!PRMetaEditCommand methodsFor: 'events' stamp: 'lr 9/26/2007 19:54'!
doExecute
	super doExecute.
	self metamodel do: [ :each | each beEditable; beSearchable ]! !

!PRMetaEditCommand methodsFor: 'accessing' stamp: 'lr 9/26/2007 19:41'!
metamodel
	^ self structure metamodel! !

!PRMetaEditCommand methodsFor: 'private' stamp: 'lr 9/26/2007 19:30'!
readUsing: aDescription
	^ self metamodel readUsing: aDescription! !

!PRMetaEditCommand methodsFor: 'private' stamp: 'lr 9/26/2007 19:30'!
write: anObject using: aDescription
	self metamodel write: anObject using: aDescription! !
